"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.is = exports.StringSchema = exports.SizeBounds = exports.RAW = exports.NumericBounds = exports.NumberSchema = exports.IntegerSchema = void 0;
var _schema = /*#__PURE__*/require("@traversable/schema");
const RAW = exports.RAW = {
  any: {
    type: 'object',
    properties: {},
    nullable: true
  },
  null: {
    type: 'null',
    enum: [null]
  },
  boolean: {
    type: 'boolean'
  },
  integer: {
    type: 'integer'
  },
  number: {
    type: 'number'
  },
  string: {
    type: 'string'
  }
};
const JsonSchema_any = /*#__PURE__*/_schema.t.eq(RAW.any);
const JsonSchema_null = /*#__PURE__*/_schema.t.eq(RAW.null);
const JsonSchema_boolean = /*#__PURE__*/_schema.t.eq(RAW.boolean);
const NumericBounds = exports.NumericBounds = /*#__PURE__*/_schema.t.object({
  minimum: /*#__PURE__*/_schema.t.optional(_schema.t.number),
  maximum: /*#__PURE__*/_schema.t.optional(_schema.t.number),
  exclusiveMinimum: /*#__PURE__*/_schema.t.optional(_schema.t.number),
  exclusiveMaximum: /*#__PURE__*/_schema.t.optional(_schema.t.number)
});
const SizeBounds = exports.SizeBounds = /*#__PURE__*/_schema.t.object({
  minLength: /*#__PURE__*/_schema.t.optional(_schema.t.number),
  maxLength: /*#__PURE__*/_schema.t.optional(_schema.t.number)
});
const JsonSchema_integer = exports.IntegerSchema = /*#__PURE__*/_schema.t.object({
  type: /*#__PURE__*/_schema.t.eq('integer'),
  ...NumericBounds.def
});
const JsonSchema_number = exports.NumberSchema = /*#__PURE__*/_schema.t.object({
  type: /*#__PURE__*/_schema.t.eq('number'),
  ...NumericBounds.def
});
const JsonSchema_string = exports.StringSchema = /*#__PURE__*/_schema.t.object({
  type: /*#__PURE__*/_schema.t.eq('string'),
  ...SizeBounds.def
});
const JsonSchema_const = /*#__PURE__*/_schema.t.object({
  const: _schema.t.unknown
});
const JsonSchema_enum_ = /*#__PURE__*/_schema.t.object({
  enum: /*#__PURE__*/_schema.t.array(_schema.t.unknown, 'readonly')
});
const JsonSchema_enum = /*#__PURE__*/_schema.t.of(u => JsonSchema_enum_(u));
const JsonSchema_array = /*#__PURE__*/_schema.t.object({
  type: /*#__PURE__*/_schema.t.eq('array'),
  items: _schema.t.unknown
});
const JsonSchema_record_ = /*#__PURE__*/_schema.t.object({
  type: /*#__PURE__*/_schema.t.eq('object'),
  additionalProperties: _schema.t.unknown
});
const JsonSchema_record = u => JsonSchema_record_(u);
const JsonSchema_union_ = /*#__PURE__*/_schema.t.object({
  anyOf: /*#__PURE__*/_schema.t.array(_schema.t.unknown, 'readonly')
});
const JsonSchema_union = /*#__PURE__*/_schema.t.of(u => JsonSchema_union_(u));
const JsonSchema_intersect_ = /*#__PURE__*/_schema.t.object({
  allOf: /*#__PURE__*/_schema.t.array(_schema.t.unknown, 'readonly')
});
const JsonSchema_intersect = /*#__PURE__*/_schema.t.of(u => JsonSchema_intersect_(u));
const JsonSchema_object = /*#__PURE__*/_schema.t.object({
  type: /*#__PURE__*/_schema.t.eq('object'),
  required: /*#__PURE__*/_schema.t.array(_schema.t.string),
  properties: _schema.t.unknown
});
const JsonSchema_tuple = /*#__PURE__*/_schema.t.object({
  type: /*#__PURE__*/_schema.t.eq('array'),
  items: _schema.t.unknown,
  minItems: _schema.t.number,
  maxItems: _schema.t.number,
  additionalItems: /*#__PURE__*/_schema.t.eq(false)
});
const JsonSchema_nullary = /*#__PURE__*/_schema.t.union(JsonSchema_any, JsonSchema_null, JsonSchema_boolean, JsonSchema_integer, JsonSchema_number, JsonSchema_string);
const JsonSchema_special = /*#__PURE__*/_schema.t.union(JsonSchema_enum, JsonSchema_const);
const JsonSchema_unary = /*#__PURE__*/_schema.t.union(JsonSchema_array, JsonSchema_record, JsonSchema_union, JsonSchema_intersect, JsonSchema_tuple, JsonSchema_object);
const is = exports.is = {
  any: JsonSchema_any,
  null: JsonSchema_null,
  boolean: JsonSchema_boolean,
  integer: JsonSchema_integer,
  number: JsonSchema_number,
  string: JsonSchema_string,
  enum: JsonSchema_enum,
  const: JsonSchema_const,
  array: JsonSchema_array,
  record: JsonSchema_record,
  union: JsonSchema_union,
  intersect: JsonSchema_intersect,
  tuple: JsonSchema_tuple,
  object: JsonSchema_object,
  nullary: JsonSchema_nullary,
  unary: JsonSchema_unary,
  special: JsonSchema_special
};
//# sourceMappingURL=specification.js.map